texture lastframe;
texture lastpass;

PixelShader MotionBlur = asm
{
	ps.1.1
	tex t0
	tex t1
	mov_d2 r0,c0
	lrp r0,r0,t1,t0
};
PixelShader Blur = asm
{
	ps.1.4
	def c0,0.00125,0,0,1
	def c1,0,0.00166667,0,1
	texcrd r0.rgb,t0
	mov r4.rgb,r0
	sub r3.rgb,r0,c1
	sub r2.rgb,r0,c0
	add r1.rgb,r0,c1
	add r0.rgb,r0,c0
	phase
	texld r0,r0
	texld r1,r1
	texld r2,r2
	texld r3,r3
	texld r4,r4
	add r0,r0,r1
	add r0,r0,r2
	add_d4 r0,r0,r3
	lrp r0,c2,r0,r4
};

Vector blindlevel = { 0,0,0,1 };
Vector blurlevel = { 0,0,0,0 };

Technique blur
{
	Pass P0
	{
		Texture[1] = <lastframe>;
		PixelShaderConstant[0] = <blurlevel>;
		PixelShader = <MotionBlur>;
	}

	Pass P1
	{
		Texture[0] = <lastpass>;
		Texture[1] = <lastpass>;
		Texture[2] = <lastpass>;
		Texture[3] = <lastpass>;
		Texture[4] = <lastpass>;
		PixelShaderConstant[2]=<blurlevel>;
		PixelShader = <Blur>;
	}
	Pass P2 { PixelShaderConstant[2]=<blurlevel>; PixelShader = <Blur>; }
	Pass P3 { PixelShaderConstant[2]=<blurlevel>; PixelShader = <Blur>; }
	Pass P4 { PixelShaderConstant[2]=<blurlevel>; PixelShader = <Blur>; }
	Pass P5 { PixelShaderConstant[2]=<blurlevel>; PixelShader = <Blur>; }
	Pass P6 { PixelShaderConstant[2]=<blurlevel>; PixelShader = <Blur>; }
	Pass P7 { PixelShaderConstant[2]=<blurlevel>; PixelShader = <Blur>; }
	Pass P8 { PixelShaderConstant[2]=<blurlevel>; PixelShader = <Blur>; }
	Pass P9 { PixelShaderConstant[2]=<blurlevel>; PixelShader = <Blur>; }
}

Technique blind
{
	Pass P0
	{
		Texture[1] = <lastframe>;
		PixelShaderConstant[0] = <blurlevel>;
		PixelShader = <MotionBlur>;
	}

	Pass P1
	{
		Texture[0] = <lastpass>;
		Texture[1] = <lastpass>;
		Texture[2] = <lastpass>;
		Texture[3] = <lastpass>;
		Texture[4] = <lastpass>;
		PixelShaderConstant[2]=<blurlevel>;
		PixelShader = <Blur>;
	}
	Pass P2 { PixelShaderConstant[2]=<blurlevel>; PixelShader = <Blur>; }
	Pass P3 { PixelShaderConstant[2]=<blurlevel>; PixelShader = <Blur>; }
	Pass P4 { PixelShaderConstant[2]=<blurlevel>; PixelShader = <Blur>; }
	Pass P5 { PixelShaderConstant[2]=<blurlevel>; PixelShader = <Blur>; }
	Pass P6 { PixelShaderConstant[2]=<blurlevel>; PixelShader = <Blur>; }
	Pass P7 { PixelShaderConstant[2]=<blurlevel>; PixelShader = <Blur>; }
	Pass P8 { PixelShaderConstant[2]=<blurlevel>; PixelShader = <Blur>; }
	Pass P9 { PixelShaderConstant[2]=<blurlevel>; PixelShader = <Blur>; }
	Pass Blind
	{ 
		PixelShaderConstant[1]=<blindlevel>;
		PixelShader = asm
		{
			ps.1.1
			def c0,0.5,0.5,0,1

			texcoord t0 
			tex t1
			mov r0,t0_bx2
			mul r0,r0,r0
			dp3_sat r0,1-r0,c0
			sub r0,r0,c1
			mul_sat r0.rgb,t1,r0
			+mov r0.a,c0
		};
	}
}